happstack-server-7.9.3: Web related tools and services.

Safe Haskell | None
Language | Haskell2010

Happstack.Server.Types

Synopsis

- data Request = Request {
  - rqSecure :: Bool
  - rqMethod :: Method
  - rqPaths :: [String]
  - rqUri :: String
  - rqQuery :: String
  - rqInputsQuery :: [(String, Input)]
  - rqInputsBody :: MVar [(String, Input)]
  - rqCookies :: [(String, Cookie)]
  - rqVersion :: HttpVersion
  - rqHeaders :: Headers
  - rqBody :: MVar RqBody
  - rqPeer :: Host
  }
- data Response
  - = Response {
    - rsCode :: Int
    - rsHeaders :: Headers
    - rsFlags :: RsFlags
    - rsBody :: ByteString
    - rsValidator :: Maybe (Response -> IO Response)
    }
  - | SendFile {
    - rsCode :: Int
    - rsHeaders :: Headers
    - rsFlags :: RsFlags
    - rsValidator :: Maybe (Response -> IO Response)
    - sfFilePath :: FilePath
    - sfOffset :: Integer
    - sfCount :: Integer
    }
- newtype RqBody = Body {
  - unBody :: ByteString
  }
- data Input = Input {
  - inputValue :: Either FilePath ByteString
  - inputFilename :: Maybe FilePath
  - inputContentType :: ContentType
  }
- data HeaderPair = HeaderPair {
  - hName :: ByteString
  - hValue :: [ByteString]
  }
- takeRequestBody :: MonadIO m => Request -> m (Maybe RqBody)
- readInputsBody :: Request -> IO (Maybe [(String, Input)])
- rqURL :: Request -> String
- mkHeaders :: [(String, String)] -> Headers
- getHeader :: HasHeaders r => String -> r -> Maybe ByteString
- getHeaderBS :: HasHeaders r => ByteString -> r -> Maybe ByteString
- getHeaderUnsafe :: HasHeaders r => ByteString -> r -> Maybe ByteString
- hasHeader :: HasHeaders r => String -> r -> Bool
- hasHeaderBS :: HasHeaders r => ByteString -> r -> Bool
- hasHeaderUnsafe :: HasHeaders r => ByteString -> r -> Bool
- setHeader :: HasHeaders r => String -> String -> r -> r
- setHeaderBS :: HasHeaders r => ByteString -> ByteString -> r -> r
- setHeaderUnsafe :: HasHeaders r => ByteString -> HeaderPair -> r -> r
- addHeader :: HasHeaders r => String -> String -> r -> r
- addHeaderBS :: HasHeaders r => ByteString -> ByteString -> r -> r
- addHeaderUnsafe :: HasHeaders r => ByteString -> HeaderPair -> r -> r
- setRsCode :: Monad m => Int -> Response -> m Response
- type LogAccess time = String -> String -> time -> String -> Int -> Integer -> String -> String -> IO ()
- logMAccess :: FormatTime t => LogAccess t
- data Conf = Conf {
  - port :: Int
  - validator :: Maybe (Response -> IO Response)
  - logAccess :: forall t. FormatTime t => Maybe (LogAccess t)
  - timeout :: Int
  - threadGroup :: Maybe ThreadGroup
  }
- nullConf :: Conf
- result :: Int -> String -> Response
- resultBS :: Int -> ByteString -> Response
- redirect :: ToSURI s => Int -> s -> Response -> Response
- isHTTP1_0 :: Request -> Bool
- isHTTP1_1 :: Request -> Bool
- data RsFlags = RsFlags {
  - rsfLength :: Length
  }
- nullRsFlags :: RsFlags
- contentLength :: Response -> Response
- chunked :: Response -> Response
- noContentLength :: Response -> Response
- data HttpVersion = HttpVersion Int Int
- data Length
  - = ContentLength
  - | TransferEncodingChunked
  - | NoContentLength
- data Method
  - = GET
  - | HEAD
  - | POST
  - | PUT
  - | DELETE
  - | TRACE
  - | OPTIONS
  - | CONNECT
  - | PATCH
  - | EXTENSION ByteString
- type Headers = Map ByteString HeaderPair
- continueHTTP :: Request -> Response -> Bool
- type Host = (String, Int)
- data ContentType = ContentType {
  - ctType :: String
  - ctSubtype :: String
  - ctParameters :: [(String, String)]
  }
- readDec' :: (Num a, Eq a) => String -> a
- fromReadS :: [(a, String)] -> Maybe a
- class FromReqURI a where
  - fromReqURI :: String -> Maybe a

# Documentation

data Request Source #

an HTTP request

Constructors

Request |

Fields

- rqSecure :: Bool

  request uses https://

- rqMethod :: Method

  request method

- rqPaths :: [String]

  the uri, split on /, and then decoded

- rqUri :: String

  the raw rqUri

- rqQuery :: String

  the QUERY_STRING

- rqInputsQuery :: [(String, Input)]

  the QUERY_STRING decoded as key/value pairs

- rqInputsBody :: MVar [(String, Input)]

  the request body decoded as key/value pairs (when appropriate)

- rqCookies :: [(String, Cookie)]

  cookies

- rqVersion :: HttpVersion

  HTTP version

- rqHeaders :: Headers

  the HTTP request headers

- rqBody :: MVar RqBody

  the raw, undecoded request body

- rqPeer :: Host

  (hostname, port) of the client making the request

#### Instances

Instances details

Show Request Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods showsPrec :: Int -> Request -> ShowS Source # show :: Request -> String Source # showList :: [Request] -> ShowS Source #

data Response Source #

an HTTP Response

Constructors

Response |

Fields

- rsCode :: Int
- rsHeaders :: Headers
- rsFlags :: RsFlags
- rsBody :: ByteString
- rsValidator :: Maybe (Response -> IO Response)

SendFile |

Fields

- rsCode :: Int
- rsHeaders :: Headers
- rsFlags :: RsFlags
- rsValidator :: Maybe (Response -> IO Response)
- sfFilePath :: FilePath

  file handle to send from

- sfOffset :: Integer

  offset to start at

- sfCount :: Integer

  number of bytes to send

#### Instances

Instances details

Show Response Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods showsPrec :: Int -> Response -> ShowS Source # show :: Response -> String Source # showList :: [Response] -> ShowS Source #
ToMessage Response Source # |
Instance details Defined in Happstack.Server.Response Methods toContentType :: Response -> ByteString Source # toMessage :: Response -> ByteString Source # toResponse :: Response -> Response Source #
Monad m => FilterMonad Response (ServerPartT m) Source # |
Instance details Defined in Happstack.Server.Internal.Monads Methods setFilter :: (Response -> Response) -> ServerPartT m () Source # composeFilter :: (Response -> Response) -> ServerPartT m () Source # getFilter :: ServerPartT m b -> ServerPartT m (b, Response -> Response) Source #
Monad m => FilterMonad Response (WebT m) Source # |
Instance details Defined in Happstack.Server.Internal.Monads Methods setFilter :: (Response -> Response) -> WebT m () Source # composeFilter :: (Response -> Response) -> WebT m () Source # getFilter :: WebT m b -> WebT m (b, Response -> Response) Source #
Monad m => WebMonad Response (ServerPartT m) Source # |
Instance details Defined in Happstack.Server.Internal.Monads Methods finishWith :: Response -> ServerPartT m b Source #
Monad m => WebMonad Response (WebT m) Source # |
Instance details Defined in Happstack.Server.Internal.Monads Methods finishWith :: Response -> WebT m b Source #

newtype RqBody Source #

The body of an HTTP `Request`

Constructors

Body |

Fields

- unBody :: ByteString

#### Instances

Instances details

Read RqBody Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods readsPrec :: Int -> ReadS RqBody Source # readList :: ReadS [RqBody] Source # readPrec :: ReadPrec RqBody Source # readListPrec :: ReadPrec [RqBody] Source #
Show RqBody Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods showsPrec :: Int -> RqBody -> ShowS Source # show :: RqBody -> String Source # showList :: [RqBody] -> ShowS Source #

data Input Source #

a value extract from the `QUERY_STRING` or `Request` body

If the input value was a file, then it will be saved to a temporary file on disk and `inputValue` will contain `Left pathToTempFile`.

Constructors

Input |

Fields

- inputValue :: Either FilePath ByteString
- inputFilename :: Maybe FilePath
- inputContentType :: ContentType

#### Instances

Instances details

Read Input Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods readsPrec :: Int -> ReadS Input Source # readList :: ReadS [Input] Source # readPrec :: ReadPrec Input Source # readListPrec :: ReadPrec [Input] Source #
Show Input Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods showsPrec :: Int -> Input -> ShowS Source # show :: Input -> String Source # showList :: [Input] -> ShowS Source #
MonadReader RqEnv RqData Source # |
Instance details Defined in Happstack.Server.RqData Methods ask :: RqData RqEnv Source # local :: (RqEnv -> RqEnv) -> RqData a -> RqData a Source # reader :: (RqEnv -> a) -> RqData a Source #

data HeaderPair Source #

an HTTP header

Constructors

HeaderPair |

Fields

- hName :: ByteString

  header name

- hValue :: [ByteString]

  header value (or values if multiple occurances of the header are present)

#### Instances

Instances details

Read HeaderPair Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods readsPrec :: Int -> ReadS HeaderPair Source # readList :: ReadS [HeaderPair] Source # readPrec :: ReadPrec HeaderPair Source # readListPrec :: ReadPrec [HeaderPair] Source #
Show HeaderPair Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods showsPrec :: Int -> HeaderPair -> ShowS Source # show :: HeaderPair -> String Source # showList :: [HeaderPair] -> ShowS Source #

takeRequestBody :: MonadIO m => Request -> m (Maybe RqBody) Source #

get the request body from the Request and replace it with Nothing

IMPORTANT: You can really only call this function once. Subsequent calls will return `Nothing`.

readInputsBody :: Request -> IO (Maybe [(String, Input)]) Source #

read the request body inputs

This will only work if the body inputs have already been decoded. Otherwise it will return Nothing.

rqURL :: Request -> String Source #

Converts a Request into a String representing the corresponding URL

mkHeaders :: [(String, String)] -> Headers Source #

Takes a list of (key,val) pairs and converts it into Headers. The keys will be converted to lowercase

getHeader :: HasHeaders r => String -> r -> Maybe ByteString Source #

Lookup header value. Key is case-insensitive.

getHeaderBS :: HasHeaders r => ByteString -> r -> Maybe ByteString Source #

Lookup header value. Key is a case-insensitive bytestring.

getHeaderUnsafe :: HasHeaders r => ByteString -> r -> Maybe ByteString Source #

Lookup header value with a case-sensitive key. The key must be lowercase.

hasHeader :: HasHeaders r => String -> r -> Bool Source #

Returns True if the associated key is found in the Headers. The lookup is case insensitive.

hasHeaderBS :: HasHeaders r => ByteString -> r -> Bool Source #

Acts as `hasHeader` with ByteStrings

hasHeaderUnsafe :: HasHeaders r => ByteString -> r -> Bool Source #

Acts as `hasHeaderBS` but the key is case sensitive. It should be in lowercase.

setHeader :: HasHeaders r => String -> String -> r -> r Source #

Associates the key/value pair in the headers. Forces the key to be lowercase.

setHeaderBS :: HasHeaders r => ByteString -> ByteString -> r -> r Source #

Acts as `setHeader` but with ByteStrings.

setHeaderUnsafe :: HasHeaders r => ByteString -> HeaderPair -> r -> r Source #

Sets the key to the HeaderPair. This is the only way to associate a key with multiple values via the setHeader* functions. Does not force the key to be in lowercase or guarantee that the given key and the key in the HeaderPair will match.

addHeader :: HasHeaders r => String -> String -> r -> r Source #

Add a key/value pair to the header. If the key already has a value associated with it, then the value will be appended. Forces the key to be lowercase.

addHeaderBS :: HasHeaders r => ByteString -> ByteString -> r -> r Source #

Acts as addHeader except for ByteStrings

addHeaderUnsafe :: HasHeaders r => ByteString -> HeaderPair -> r -> r Source #

Add a key/value pair to the header using the underlying HeaderPair data type. Does not force the key to be in lowercase or guarantee that the given key and the key in the HeaderPair will match.

setRsCode :: Monad m => Int -> Response -> m Response Source #

Sets the Response status code to the provided Int and lifts the computation into a Monad.

type LogAccess time = String -> String -> time -> String -> Int -> Integer -> String -> String -> IO () Source #

function to log access requests (see also: `logMAccess`) type LogAccess time = ( String -- ^ host -> String -- ^ user -> time -- ^ time -> String -- ^ requestLine -> Int -- ^ responseCode -> Integer -- ^ size -> String -- ^ referer -> String -- ^ userAgent -> IO ())

logMAccess :: FormatTime t => LogAccess t Source #

log access requests using hslogger and apache-style log formatting

see also: `Conf`

data Conf Source #

HTTP configuration

Constructors

Conf |

Fields

- port :: Int

  Port for the server to listen on.

- validator :: Maybe (Response -> IO Response)

  a function to validate the output on-the-fly

- logAccess :: forall t. FormatTime t => Maybe (LogAccess t)

  function to log access requests (see also: `logMAccess`)

- timeout :: Int

  number of seconds to wait before killing an inactive thread

- threadGroup :: Maybe ThreadGroup

  ThreadGroup for registering spawned threads for handling requests.

nullConf :: Conf Source #

Default configuration contains no validator and the port is set to 8000

result :: Int -> String -> Response Source #

Creates a Response with the given Int as the status code and the provided String as the body of the Response

resultBS :: Int -> ByteString -> Response Source #

Acts as `result` but works with ByteStrings directly.

By default, Transfer-Encoding: chunked will be used

redirect :: ToSURI s => Int -> s -> Response -> Response Source #

Sets the Response's status code to the given Int and redirects to the given URI

isHTTP1_0 :: Request -> Bool Source #

`True` if `Request` is HTTP version `1.0`

isHTTP1_1 :: Request -> Bool Source #

`True` if `Request` is HTTP version `1.1`

data RsFlags Source #

Result flags

Constructors

RsFlags |

Fields

- rsfLength :: Length

#### Instances

Instances details

Read RsFlags Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods readsPrec :: Int -> ReadS RsFlags Source # readList :: ReadS [RsFlags] Source # readPrec :: ReadPrec RsFlags Source # readListPrec :: ReadPrec [RsFlags] Source #
Show RsFlags Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods showsPrec :: Int -> RsFlags -> ShowS Source # show :: RsFlags -> String Source # showList :: [RsFlags] -> ShowS Source #

nullRsFlags :: RsFlags Source #

Default RsFlags: automatically use `Transfer-Encoding: Chunked`.

contentLength :: Response -> Response Source #

Automatically add a Content-Length header. Do not use Transfer-Encoding: Chunked

chunked :: Response -> Response Source #

Do not automatically add a Content-Length header. Do automatically use Transfer-Encoding: Chunked

noContentLength :: Response -> Response Source #

Do not automatically add a Content-Length field to the `Response`

data HttpVersion Source #

HTTP version

Constructors

HttpVersion Int Int |

#### Instances

Instances details

Read HttpVersion Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods readsPrec :: Int -> ReadS HttpVersion Source # readList :: ReadS [HttpVersion] Source # readPrec :: ReadPrec HttpVersion Source # readListPrec :: ReadPrec [HttpVersion] Source #
Show HttpVersion Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods showsPrec :: Int -> HttpVersion -> ShowS Source # show :: HttpVersion -> String Source # showList :: [HttpVersion] -> ShowS Source #
Eq HttpVersion Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods (==) :: HttpVersion -> HttpVersion -> Bool Source # (/=) :: HttpVersion -> HttpVersion -> Bool Source #

data Length Source #

A flag value set in the `Response` which controls how the `Content-Length` header is set, and whether *chunked* output encoding is used.

see also: `nullRsFlags`, `notContentLength`, and `chunked`

Constructors

ContentLength | automatically add a `Content-Length` header to the `Response`
TransferEncodingChunked | do not add a `Content-Length` header. Do use `chunked` output encoding
NoContentLength | do not set `Content-Length` or `chunked` output encoding.

#### Instances

Instances details

Enum Length Source # |

Instance details

Defined in Happstack.Server.Internal.Types

Methods

succ :: Length -> Length Source #

pred :: Length -> Length Source #

toEnum :: Int -> Length Source #

fromEnum :: Length -> Int Source #

enumFrom :: Length -> [Length] Source #

enumFromThen :: Length -> Length -> [Length] Source #

enumFromTo :: Length -> Length -> [Length] Source #

enumFromThenTo :: Length -> Length -> Length -> [Length] Source #

Read Length Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods readsPrec :: Int -> ReadS Length Source # readList :: ReadS [Length] Source # readPrec :: ReadPrec Length Source # readListPrec :: ReadPrec [Length] Source #
Show Length Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods showsPrec :: Int -> Length -> ShowS Source # show :: Length -> String Source # showList :: [Length] -> ShowS Source #
Eq Length Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods (==) :: Length -> Length -> Bool Source # (/=) :: Length -> Length -> Bool Source #
Ord Length Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods compare :: Length -> Length -> Ordering Source # (<) :: Length -> Length -> Bool Source # (<=) :: Length -> Length -> Bool Source # (>) :: Length -> Length -> Bool Source # (>=) :: Length -> Length -> Bool Source # max :: Length -> Length -> Length Source # min :: Length -> Length -> Length Source #

data Method Source #

HTTP request method

Constructors

GET |
HEAD |
POST |
PUT |
DELETE |
TRACE |
OPTIONS |
CONNECT |
PATCH |
EXTENSION ByteString |

#### Instances

Instances details

Data Method Source # |

Instance details

Defined in Happstack.Server.Internal.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Method -> c Method Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Method Source #

toConstr :: Method -> Constr Source #

dataTypeOf :: Method -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Method) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Method) Source #

gmapT :: (forall b. Data b => b -> b) -> Method -> Method Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Method -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Method -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Method -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Method -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Method -> m Method Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Method -> m Method Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Method -> m Method Source #

Read Method Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods readsPrec :: Int -> ReadS Method Source # readList :: ReadS [Method] Source # readPrec :: ReadPrec Method Source # readListPrec :: ReadPrec [Method] Source #
Show Method Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods showsPrec :: Int -> Method -> ShowS Source # show :: Method -> String Source # showList :: [Method] -> ShowS Source #
Eq Method Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods (==) :: Method -> Method -> Bool Source # (/=) :: Method -> Method -> Bool Source #
Ord Method Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods compare :: Method -> Method -> Ordering Source # (<) :: Method -> Method -> Bool Source # (<=) :: Method -> Method -> Bool Source # (>) :: Method -> Method -> Bool Source # (>=) :: Method -> Method -> Bool Source # max :: Method -> Method -> Method Source # min :: Method -> Method -> Method Source #
MatchMethod Method Source # |
Instance details Defined in Happstack.Server.Routing Methods matchMethod :: Method -> Method -> Bool Source #
MatchMethod [Method] Source # |
Instance details Defined in Happstack.Server.Routing Methods matchMethod :: [Method] -> Method -> Bool Source #
MatchMethod (Method -> Bool) Source # |
Instance details Defined in Happstack.Server.Routing Methods matchMethod :: (Method -> Bool) -> Method -> Bool Source #

type Headers Source #

Arguments

= Map ByteString HeaderPair | lowercased name -> (realname, value)

a Map of HTTP headers

the Map key is the header converted to lowercase

continueHTTP :: Request -> Response -> Bool Source #

Should the connection be used for further messages after this. isHTTP1_0 && hasKeepAlive || isHTTP1_1 && hasNotConnectionClose

In addition to this rule All 1xx (informational), 204 (no content), and 304 (not modified) responses MUST NOT include a message-body and therefore are eligible for connection keep-alive.

type Host Source #

Arguments

= (String, Int) | (hostname, port)

hostname & port

data ContentType Source #

A MIME media type value. The `Show` instance is derived automatically. Use `showContentType` to obtain the standard string representation. See http://www.ietf.org/rfc/rfc2046.txt for more information about MIME media types.

Constructors

ContentType |

Fields

- ctType :: String

  The top-level media type, the general type of the data. Common examples are "text", "image", "audio", "video", "multipart", and "application".

- ctSubtype :: String

  The media subtype, the specific data format. Examples include "plain", "html", "jpeg", "form-data", etc.

- ctParameters :: [(String, String)]

  Media type parameters. On common example is the charset parameter for the "text" top-level type, e.g. `("charset","ISO-8859-1")`.

#### Instances

Instances details

Read ContentType Source # |
Instance details Defined in Happstack.Server.Internal.RFC822Headers Methods readsPrec :: Int -> ReadS ContentType Source # readList :: ReadS [ContentType] Source # readPrec :: ReadPrec ContentType Source # readListPrec :: ReadPrec [ContentType] Source #
Show ContentType Source # |
Instance details Defined in Happstack.Server.Internal.RFC822Headers Methods showsPrec :: Int -> ContentType -> ShowS Source # show :: ContentType -> String Source # showList :: [ContentType] -> ShowS Source #
Eq ContentType Source # |
Instance details Defined in Happstack.Server.Internal.RFC822Headers Methods (==) :: ContentType -> ContentType -> Bool Source # (/=) :: ContentType -> ContentType -> Bool Source #
Ord ContentType Source # |

Instance details

Defined in Happstack.Server.Internal.RFC822Headers

Methods

compare :: ContentType -> ContentType -> Ordering Source #

(<) :: ContentType -> ContentType -> Bool Source #

(<=) :: ContentType -> ContentType -> Bool Source #

(>) :: ContentType -> ContentType -> Bool Source #

(>=) :: ContentType -> ContentType -> Bool Source #

max :: ContentType -> ContentType -> ContentType Source #

min :: ContentType -> ContentType -> ContentType Source #

readDec' :: (Num a, Eq a) => String -> a Source #

fromReadS :: [(a, String)] -> Maybe a Source #

convert a 'ReadS a' result to 'Maybe a'

class FromReqURI a where Source #

This class is used by `path` to parse a path component into a value.

The instances for number types (`Int`, `Float`, etc) use `readM` to parse the path component.

The instance for `String`, on the other hand, returns the unmodified path component.

See the following section of the Happstack Crash Course for detailed instructions using and extending `FromReqURI`:

http://www.happstack.com/docs/crashcourse/RouteFilters.html#FromReqURI

Methods

fromReqURI :: String -> Maybe a Source #

#### Instances

Instances details

FromReqURI Int16 Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Int16 Source #
FromReqURI Int32 Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Int32 Source #
FromReqURI Int64 Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Int64 Source #
FromReqURI Int8 Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Int8 Source #
FromReqURI Word16 Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Word16 Source #
FromReqURI Word32 Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Word32 Source #
FromReqURI Word64 Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Word64 Source #
FromReqURI Word8 Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Word8 Source #
FromReqURI Text Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Text Source #
FromReqURI Text Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Text Source #
FromReqURI Integer Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Integer Source #
FromReqURI String Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe String Source #
FromReqURI Bool Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Bool Source #
FromReqURI Char Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Char Source #
FromReqURI Double Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Double Source #
FromReqURI Float Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Float Source #
FromReqURI Int Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Int Source #
FromReqURI Word Source # |
Instance details Defined in Happstack.Server.Internal.Types Methods fromReqURI :: String -> Maybe Word Source #